##
## Copyright (c) 2021 The Yaook Authors.
##
## This file is part of Yaook.
## See https://yaook.cloud for further info.
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
---
stages:
  - build
  - bumpversion


build:
  image: "${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/docker:27.5.1"
  variables:
    DOCKER_TLS_CERTDIR: ""
    DOCKER_DRIVER: overlay2
    DOCKER_HOST: tcp://docker:2375
    DOCKER_BUILDKIT: 1
  services:
    - name: "${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/docker:27.5.1-dind"
      alias: docker
  before_script:
    - mkdir $HOME/.docker
    - docker login "${REGISTRY_URL}" -u "${REGISTRY_USER}" -p "${REGISTRY_PASS}"
    - docker login -u "$CI_DEPENDENCY_PROXY_USER" -p "$CI_DEPENDENCY_PROXY_PASSWORD" "$CI_DEPENDENCY_PROXY_SERVER"
    # The following is magic to get the dockerhub images using the gitlab dependency proxy without specifying these images in the Dockerfile
    # This allows use to ignore the dockerhub rate limit while allowing security analyzers to still pick up dockerhub changes
    - for i in $(grep FROM Dockerfile | awk '{print $2}' | sort | uniq); do docker pull "${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/${i}"; docker tag "${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/${i}" "${i}"; done
  stage: build
  script:
    - BRANCH_IMAGE_NAME="${REGISTRY_URL}/${REGISTRY_PROJECT}/${CI_PROJECT_NAME}"
    - BRANCH_IMAGE_TAG="$BRANCH_IMAGE_NAME:$CI_COMMIT_REF_SLUG"
    - docker build . -t "$BRANCH_IMAGE_TAG"
    - docker push "$BRANCH_IMAGE_TAG"
    - if [ "$CI_COMMIT_REF_PROTECTED" = "true" ]; then VERSION=$(cat .next-version); RELEASE_IMAGE_TAG="$BRANCH_IMAGE_NAME:$VERSION"; docker tag "$BRANCH_IMAGE_TAG" "$RELEASE_IMAGE_TAG"; docker push "$RELEASE_IMAGE_TAG"; fi
  except:
    - tags

version:
  image: "${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/python:latest"
  stage: bumpversion
  script:
    - pip install bump2version
    - git config --global user.name "${GITLAB_USER_NAME}"
    - git config --global user.email "${GITLAB_USER_EMAIL}"
    - bump2version --current-version "$(cat .next-version)" patch .next-version --commit
    - git remote set-url origin "https://gitlab-ci-token:${BOT_GIT_PUSH_ACCESS_TOKEN}@${CI_SERVER_HOST}/${CI_PROJECT_PATH}.git"
    - git push -o ci.skip origin HEAD:${CI_COMMIT_REF_NAME}
  only:
    - devel
